register {Userlist Viewer} 1.3 {Provides a unique way to view Turf's userlist, allowing the user to specify the ordering of the users and which categories of users should be listed.}

if {[catch {
    if {$::PREFS(FIRST) == 1} {}
}] == 1} {
    set ::PREFS(FIRST) "level"
    set ::PREFS(SECOND) "name"
    set ::PREFS(THIRD) "none"
}
lappend ::Preferences::hooks "::Userlist::prefs"
lappend ::Preferences::applys "::Userlist::apply"

proc install_userlist {} {
    global triggers
    .menubar.turf add command -label "Userlist Viewer" -command Userlist::init

    set text {^.* the .* has signed on.$}
    set triggers($text) {
	Userlist::update
    }

    set text {^.* has signed off.$}
    set triggers($text) {
	Userlist::update
    }

    set text {^.* has lost .* link.$}
    set triggers($text) {
	Userlist::update
    }

    set text {^.* has reconnected.$}
    set triggers($text) {
	Userlist::update
    }
    Userlist::load_settings
}
 
proc unload_userlist {} {
    global triggers
    Userlist::uninit

    set text {^.* has signed off.$}
    unset triggers($text)

    set text {^.* the .* has signed on.$}
    unset triggers($text)

    set text {^.* has lost .* link.$}
    unset triggers($text)
    
    set text {^.* has reconnected.$}
    unset triggers($text)

    set ::Preferences::hooks [lreplace $::Preferences::hooks [lsearch $::Preferences::hooks "::Userlist::prefs"] [lsearch $::Preferences::hooks "::Userlist::prefs"]]
    set ::Preferences::applys [lreplace $::Preferences::applys [lsearch $::Preferences::applys "::Userlist::apply"] [lsearch $::Preferences::applys "::Userlist::apply"]]
}

namespace eval Userlist {
    
    proc prefs {} {
	global order_by

	set win [ButtonNotebook::newpage .prefs.main {Userlist}]

	frame $win.userlist
	pack $win.userlist -side top -fill x

	frame $win.userlist.name
	frame $win.userlist.first
	frame $win.userlist.second
	frame $win.userlist.third
	
	pack $win.userlist.name -side left -fill x
	pack $win.userlist.first -side left -fill x
	pack $win.userlist.second -side left -fill x
	pack $win.userlist.third -side left -fill x

	label $win.userlist.name.name -text "Name"
	label $win.userlist.name.clan -text "Clan"
	label $win.userlist.name.level -text "Level"
	label $win.userlist.name.class -text "Class"
	label $win.userlist.name.invis -text "Invis"
	label $win.userlist.name.wizinvis -text "WizInvis"
	label $win.userlist.name.friend -text "Friend"
	label $win.userlist.name.afk -text "AFK"
	label $win.userlist.name.none -text "None"

	radiobutton $win.userlist.first.namefirst -variable ::PREFS(FIRST) -value name
	radiobutton $win.userlist.first.clanfirst -variable ::PREFS(FIRST) -value clan
	radiobutton $win.userlist.first.levelfirst -variable ::PREFS(FIRST) -value level
	radiobutton $win.userlist.first.classfirst -variable ::PREFS(FIRST) -value class
	radiobutton $win.userlist.first.invisfirst -variable ::PREFS(FIRST) -value invis
	radiobutton $win.userlist.first.wizinvisfirst -variable ::PREFS(FIRST) -value wizinvis
	radiobutton $win.userlist.first.friendfirst -variable ::PREFS(FIRST) -value friend
	radiobutton $win.userlist.first.afkfirst -variable ::PREFS(FIRST) -value afk
	radiobutton $win.userlist.first.nonefirst -variable ::PREFS(FIRST) -value none

	radiobutton $win.userlist.second.namesecond -variable ::PREFS(SECOND) -value name
	radiobutton $win.userlist.second.clansecond -variable ::PREFS(SECOND) -value clan
	radiobutton $win.userlist.second.levelsecond -variable ::PREFS(SECOND) -value level
	radiobutton $win.userlist.second.classsecond -variable ::PREFS(SECOND) -value class
	radiobutton $win.userlist.second.invissecond -variable ::PREFS(SECOND) -value invis
	radiobutton $win.userlist.second.wizinvissecond -variable ::PREFS(SECOND) -value wizinvis
	radiobutton $win.userlist.second.friendsecond -variable ::PREFS(SECOND) -value friend
	radiobutton $win.userlist.second.afksecond -variable ::PREFS(SECOND) -value afk
	radiobutton $win.userlist.second.nonesecond -variable ::PREFS(SECOND) -value none


	radiobutton $win.userlist.third.namethird -variable ::PREFS(THIRD) -value name
	radiobutton $win.userlist.third.clanthird -variable ::PREFS(THIRD) -value clan
	radiobutton $win.userlist.third.levelthird -variable ::PREFS(THIRD) -value level
	radiobutton $win.userlist.third.classthird -variable ::PREFS(THIRD) -value class
	radiobutton $win.userlist.third.invisthird -variable ::PREFS(THIRD) -value invis
	radiobutton $win.userlist.third.wizinvisthird -variable ::PREFS(THIRD) -value wizinvis
	radiobutton $win.userlist.third.friendthird -variable ::PREFS(THIRD) -value friend
	radiobutton $win.userlist.third.afkthird -variable ::PREFS(THIRD) -value afk
	radiobutton $win.userlist.third.nonethird -variable ::PREFS(THIRD) -value none

	grid $win.userlist.name.name
	grid $win.userlist.name.clan
	grid $win.userlist.name.level
	grid $win.userlist.name.class
	grid $win.userlist.name.invis
	grid $win.userlist.name.wizinvis
	grid $win.userlist.name.friend
	grid $win.userlist.name.afk
	grid $win.userlist.name.none

	grid $win.userlist.first.namefirst -sticky we
	grid $win.userlist.first.clanfirst
	grid $win.userlist.first.levelfirst
	grid $win.userlist.first.classfirst
	grid $win.userlist.first.invisfirst
	grid $win.userlist.first.wizinvisfirst
	grid $win.userlist.first.friendfirst
	grid $win.userlist.first.afkfirst
	grid $win.userlist.first.nonefirst

	grid $win.userlist.second.namesecond -sticky we
	grid $win.userlist.second.clansecond
	grid $win.userlist.second.levelsecond
	grid $win.userlist.second.classsecond
	grid $win.userlist.second.invissecond
	grid $win.userlist.second.wizinvissecond
	grid $win.userlist.second.friendsecond
	grid $win.userlist.second.afksecond
	grid $win.userlist.second.nonesecond

	grid $win.userlist.third.namethird -sticky we
	grid $win.userlist.third.clanthird
	grid $win.userlist.third.levelthird
	grid $win.userlist.third.classthird
	grid $win.userlist.third.invisthird
	grid $win.userlist.third.wizinvisthird
	grid $win.userlist.third.friendthird
	grid $win.userlist.third.afkthird
	grid $win.userlist.third.nonethird

	set ::Userlist::win $win
    }

    proc apply {} {
	global order_by

	set order_by {}
	lappend order_by $::PREFS(FIRST)
	lappend order_by $::PREFS(SECOND)
	lappend order_by $::PREFS(THIRD)

	# Fill this with the stuff needed to apply.
	Userlist::update
    }

    proc uninit {} {
	global window_open
	set window_open 0
	destroy .userlist
	.menubar.turf delete [.menubar.turf index "Userlist Viewer"] [.menubar.turf index "Userlist Viewer"]
    }

    proc load_settings {} {
	global order_by
	global window_open
	set window_open 0

	set order_by {}
	lappend order_by $::PREFS(FIRST)
	lappend order_by $::PREFS(SECOND)
	lappend order_by $::PREFS(THIRD)
    }
    
    proc close_window {} {
	global window_open
	
	set window_open 0
	destroy .userlist
    }

    proc init {} {
	global timer
	global window_open

	set window_open 0
	destroy .userlist
	toplevel .userlist
	wm title .userlist "Userlist Viewer"
	wm protocol .userlist WM_DELETE_WINDOW {Userlist::close_window}

	frame .userlist.frame
	bind .userlist <Escape> {destroy .userlist}

	canvas .userlist.frame.can -width 624 -height 200 -yscrollcommand [list .userlist.frame.yscroll set]
	scrollbar .userlist.frame.yscroll -orient vertical -command [list .userlist.frame.can yview]

	pack .userlist.frame.yscroll -side right -fill y
	pack .userlist.frame.can -side left -fill both -expand true
	pack .userlist.frame -side top -fill both -expand true

	set bbox [grid bbox .userlist.frame.can 0 0]
	set incr [lindex $bbox 3]
	set width [winfo reqwidth .userlist.frame.can]
	set height [winfo reqheight .userlist.frame.can]
	.userlist.frame.can config -scrollregion "0 0 $width $height"
	.userlist.frame.can config -yscrollincrement $incr
	set height [expr 7 * $incr]
	.userlist.frame.can config -width $width -height $height

	center .userlist
	set window_open 1

	# See if the timer variable is defined.  If it isn't, set it to 0.

	if {[catch {
	    if {$timer == 0} {}
	}] == 1} {
	    set timer 0
	}
	update
    }

    proc check {text} {
	update
    }

    proc update {} {
	global names
	global order_by
	global window_open

	if {$window_open == 0} {
	    return
	}

	set names {}

	# Need to check that we're still looking for userlist requests.
	
	request_who
	request_cwho
	request_fwho
	dummy_command

    }
    
    proc update_on_timer {} {
	global timer
	set timer 0
	update
    }

    proc display {} {
	global names
	global friend
	global invis
	global afk
	global wizinvis
	global killer
	global thief
	global clan
	global level
	global rank
	global title
	global timer

	set names [order 1 $names]
	draw_canvas

	if {$timer == 0} {
	    after 60000 Userlist::update_on_timer
	    set timer 1
	}
    }
    
    proc request_who {} {
	
	Capture::addID userlist_who Userlist::who_received
	send "c15 huserlist_who who"
	
    }
    
    proc request_cwho {} {
	
	Capture::addID userlist_cwho Userlist::cwho_received
	send "c15 huserlist_cwho cwho"

    }
    
    proc request_fwho {} {
	
	Capture::addID userlist_fwho Userlist::fwho_received
	send "c15 huserlist_fwho fwho"
	
    }
    
    proc dummy_command {} {
	Capture::addID userlist_dummy_command Userlist::dummy_command_received
	send "c15 huserlist_dummy_command dummy_command"
    }

    proc dummy_command_received {args} {
	display
    }

    proc who_received {data} {
	global names
	global friend
	global invis
	global afk
	global wizinvis
	global killer
	global thief
	global clan
	global level
	global rank
	global title

	foreach line [split $data \n] {

	    if {[regexp {^[ ]*([^ ]*) ([^ ]*)[ ]*- ([a-zA-Z]*)([^~]*)(|~ \(([a-z A-Z]*)\))$} $line dummy lev ran nam tit fla fla2] == 1} {

		if {[lsearch $names $nam] == -1} {
		    lappend names $nam
		}
		set friend($nam) 0
		set invis($nam) 0
		set afk($nam) 0
		set wizinvis($nam) 0
		set killer($nam) 0
		set thief($nam) 0
		set clan($nam) 0
		set level($nam) $lev
		set rank($nam) $ran
		set title($nam) $tit
		parse_flags $nam $fla2
	    }
	    # <spaces><text><space><text><spaces>-<anything>
	}
    }
    
    proc fwho_received {data} {
	global friend

	foreach line [split $data \n] {
	    if {[regexp {^[ ]*[^ ]* [^ ]*[ ]*- ([a-zA-Z]*).*$} $line dummy nam] == 1} {
		set friend($nam) 1
	    }
	}
    }
    
    proc cwho_received {data} {
	global clan

	foreach line [split $data \n] {
	    if {[regexp {^[ ]*[^ ]* ([^ ]*)[ ]*- ([a-zA-Z]*).*$} $line dummy cla nam] == 1} {
		set clan($nam) $cla
	    }
	}
    }

    # This procedure orders the display, according to the settings specified.

    proc order {depth array} {
	global order_by

	if {$depth > 3} {
	    return $array
	}

	set v [lindex $order_by [expr $depth - 1]]

	return [order_by_$v $depth $array]
    }

    proc order_by_none {depth array} {
	return $array
    }

    proc order_by_invis {depth array} {
	global invis
	set swap 1
	
	while {$swap == 1} {
	    set swap 0
	    set current 0
	    
	    while {$current < [expr [llength $array] - 1]} {
		set next [expr $current + 1]
		set current_name [lindex $array $current]
		set next_name [lindex $array $next]

		if {$invis($next_name) == $invis($current_name)} {
		    # Create a miniature list of the two entries
		    set tmp {}
		    lappend tmp $current_name $next_name
		    set tmp [order [expr $depth + 1] $tmp]
		    set array [lreplace $array $current $current [lindex $tmp 0]]
		    set array [lreplace $array $next $next [lindex $tmp 1]]
		    incr current
		    continue
		}

		if {$invis($next_name) > $invis($current_name)} {
		    # Swap them over
		    set swap 1
		    set array [lreplace $array $current $current "$next_name"]
		    set array [lreplace $array $next $next "$current_name"]
		}
	    incr current
	    }
	}
	return $array
    }

    proc order_by_afk {depth array} {
	global afk
	set swap 1
	
	while {$swap == 1} {
	    set swap 0
	    set current 0
	    
	    while {$current < [expr [llength $array] - 1]} {
		set next [expr $current + 1]
		set current_name [lindex $array $current]
		set next_name [lindex $array $next]

		if {$afk($next_name) == $afk($current_name)} {
		    # Create a miniature list of the two entries
		    set tmp {}
		    lappend tmp $current_name $next_name
		    set tmp [order [expr $depth + 1] $tmp]
		    set array [lreplace $array $current $current [lindex $tmp 0]]
		    set array [lreplace $array $next $next [lindex $tmp 1]]
		    incr current
		    continue
		}

		if {$afk($next_name) > $afk($current_name)} {
		    # Swap them over
		    set swap 1
		    set array [lreplace $array $current $current "$next_name"]
		    set array [lreplace $array $next $next "$current_name"]
		}
	    incr current
	    }
	}
	return $array
    }

    proc order_by_wizinvis {depth array} {
	global wizinvis
	set swap 1

	while {$swap == 1} {
	    set swap 0
	    set current 0
	    
	    while {$current < [expr [llength $array] - 1]} {
		set next [expr $current + 1]
		set current_name [lindex $array $current]
		set next_name [lindex $array $next]

		if {$wizinvis($next_name) == $wizinvis($current_name)} {
		    # Create a miniature list of the two entries
		    set tmp {}
		    lappend tmp $current_name $next_name
		    set tmp [order [expr $depth + 1] $tmp]
		    set array [lreplace $array $current $current [lindex $tmp 0]]
		    set array [lreplace $array $next $next [lindex $tmp 1]]
		    incr current
		    continue
		}

		if {$wizinvis($next_name) > $wizinvis($current_name)} {
		    # Swap them over
		    set swap 1
		    set array [lreplace $array $current $current "$next_name"]
		    set array [lreplace $array $next $next "$current_name"]
		}
		incr current
	    }
	}
	return $array
    }

    proc order_by_class {depth array} {
	global rank
	set swap 1

	while {$swap == 1} {
	    set swap 0
	    set current 0
	    
	    while {$current < [expr [llength $array] - 1]} {
		set next [expr $current + 1]
		set current_name [lindex $array $current]
		set next_name [lindex $array $next]

		if {$rank($next_name) == $rank($current_name)} {
		    # Create a miniature list of the two entries
		    set tmp {}
		    lappend tmp $current_name $next_name
		    set tmp [order [expr $depth + 1] $tmp]
		    set array [lreplace $array $current $current [lindex $tmp 0]]
		    set array [lreplace $array $next $next [lindex $tmp 1]]
		    incr current
		    continue
		}

		if {$rank($next_name) < $rank($current_name)} {
		    # Swap them over
		    set swap 1
		    set array [lreplace $array $current $current "$next_name"]
		    set array [lreplace $array $next $next "$current_name"]
		}
	    incr current
	    }
	}
	return $array
    }

    proc order_by_friend {depth array} {
	global friend
	set swap 1

	while {$swap == 1} {
	    set swap 0
	    set current 0
	    
	    while {$current < [expr [llength $array] - 1]} {
		set next [expr $current + 1]
		set current_name [lindex $array $current]
		set next_name [lindex $array $next]

		if {$friend($next_name) == $friend($current_name)} {
		    # Create a miniature list of the two entries
		    set tmp {}
		    lappend tmp $current_name $next_name
		    set tmp [order [expr $depth + 1] $tmp]
		    set array [lreplace $array $current $current [lindex $tmp 0]]
		    set array [lreplace $array $next $next [lindex $tmp 1]]
		    incr current
		    continue
		}

		if {$friend($next_name) > $friend($current_name)} {
		    # Swap them over
		    set swap 1
		    set array [lreplace $array $current $current "$next_name"]
		    set array [lreplace $array $next $next "$current_name"]
		}
	    incr current
	    }
	}
	return $array
    }

    proc order_by_clan {depth array} {
	global clan
	set swap 1

	while {$swap == 1} {
	    set swap 0
	    set current 0
	    
	    while {$current < [expr [llength $array] - 1]} {
		set next [expr $current + 1]
		set current_name [lindex $array $current]
		set next_name [lindex $array $next]

		if {$clan($next_name) == $clan($current_name)} {
		    # Create a miniature list of the two entries
		    set tmp {}
		    lappend tmp $current_name $next_name
		    set tmp [order [expr $depth + 1] $tmp]
		    set array [lreplace $array $current $current [lindex $tmp 0]]
		    set array [lreplace $array $next $next [lindex $tmp 1]]
		    incr current
		    continue
		}

		if {$clan($next_name) < $clan($current_name)} {
		    # Swap them over
		    set swap 1
		    set array [lreplace $array $current $current "$next_name"]
		    set array [lreplace $array $next $next "$current_name"]
		}
	    incr current
	    }
	}
	return $array
    }

    proc order_by_name {depth array} {
	set swap 1
	while {$swap == 1} {
	    set swap 0
	    set current 0

	    while {$current < [expr [llength $array] - 1]} {
		set next [expr $current + 1]
		set current_name [lindex $array $current]
		set next_name [lindex $array $next]

		if {$next_name == $current_name} {
		    # Create a miniature list of the two entries
		    set tmp {}
		    lappend tmp $current_name $next_name
		    set tmp [order [expr $depth + 1] $tmp]
		    set array [lreplace $array $current $current [lindex $tmp 0]]
		    set array [lreplace $array $next $next [lindex $tmp 1]]
		    incr current
		    continue
		}

		if {$next_name < $current_name} {
		    # swap
		    set swap 1
		    set array [lreplace $array $current $current "$next_name"]
		    set array [lreplace $array $next $next "$current_name"]
		}
		incr current
	    }
	}
	return $array
    }

    proc order_by_level {depth array} {
	global level

	set swap 1

	while {$swap == 1} {
	    set swap 0
	    set current 0
	    
	    while {$current < [expr [llength $array] - 1]} {
		set next [expr $current + 1]
		set current_name [lindex $array $current]
		set next_name [lindex $array $next]

		if {$level($next_name) == $level($current_name)} {
		    # Create a miniature list of the two entries
		    set tmp {}
		    lappend tmp $current_name $next_name
		    set tmp [order [expr $depth + 1] $tmp]
		    set array [lreplace $array $current $current [lindex $tmp 0]]
		    set array [lreplace $array $next $next [lindex $tmp 1]]
		    incr current
		    continue
		}

		if {$level($next_name) > $level($current_name)} {
		    # Swap them over
		    set swap 1
		    set array [lreplace $array $current $current "$next_name"]
		    set array [lreplace $array $next $next "$current_name"]
		}
	    incr current
	    }
	}
	return $array
    }

    proc parse_flags {nam flags} {
	global invis
	global wizinvis
	global thief
	global killer
	global afk

	foreach flag [split $flags " "] {

	    if {$flag == "Thief"} {
		set thief($nam) 1
		continue
	    }

	    if {$flag == "Killer"} {
		set killer($nam) 1
		continue
	    }

	    if {$flag == "WizInvis"} {
		set wizinvis($nam) 1
		continue
	    }

	    if {$flag == "Invis"} {
		set invis($nam) 1
		continue
	    }

	    if {$flag == "AFK"} {
		set afk($nam) 1
		continue
	    }

	    wintalk .twid.text "Unknown flag: $flag\n" {}
	}
    }

    proc change_friend {friend} {
	Capture::addID userlist_friend Userlist::check
	send "c15 huserlist_friend friend $friend"
    }

    proc finger {victim} {
	catch {destroy .fingerinfo}

	toplevel .fingerinfo
	wm title .fingerinfo "Finger Information"

	text .fingerinfo.box
	pack .fingerinfo.box -fill both -expand true
	center .fingerinfo

	Capture::addID userlist_finger Userlist::finger_received
	send "c15 huserlist_finger finger $victim"
    }

    proc claninfo {clan} {
	catch {destroy .claninfo}
	toplevel .claninfo
	wm title .claninfo "Clan Information"

	set text [::ScrolledTextWidget .claninfo.frame -width 80 -height 20 -wrap word -state normal -relief flat]
	pack .claninfo.frame
	center .claninfo

	Capture::addID userlist_claninfo Userlist::claninfo_received
	send "c15 huserlist_claninfo claninfo $clan"

	Capture::addID userlist_members Userlist::claninfo_received
	send "c15 huserlist_members members $clan"
    }

    proc claninfo_received {text} {
	.claninfo.frame.text insert end $text
    }

    proc finger_received {text} {
	.fingerinfo.box insert end $text
    }

    proc draw_canvas {} {

	global names
	global clan
	global title
	global invis
	global wizinvis
	global afk
	global rank
	global level
	global friend

	set y 15
	set x 20
	
	set odd 0
	set count 0

#	set font "fixed"
	set font "-adobe-helvetica-medium-r-normal--17-120-*-*-p-88-iso8859-1"


	if {$::tcl_platform(platform) == "unix"} {
	    set path "~/.tkturf/pixmaps/"
	}

	if {$::tcl_platform(platform) == "windows"} {
	    set path "/tkturf/pixmaps/"
	}

	if {$::tcl_platform(platform) == "macintosh"} {
	    set path "::tkturf:pixmaps:"
	}
	
	catch {
	    set fn "invis.ppm"
	    set invis_image [image create photo -file "$path$fn" -format ppm]
	    set fn "wizinvis.ppm"
	    set wizinvis_image [image create photo -file "$path$fn" -format ppm]
	    set fn "friend.ppm"
	    set friend_image [image create photo -file "$path$fn"]
	    
	    set fn "blank.gif"
	    set blank_image [image create photo -file "$path$fn"]

	    set fn "afk.ppm"
	    set afk_image [image create photo -file "$path$fn"]
	}
	
	# Draw a great big gray rectangle to clear the canvas.
	# Or is there a better way?
	.userlist.frame.can create rectangle 0 0 624 624 -fill gray -outline gray
	
	foreach name $names {
	    set count [expr $count + 1]
	    set x 5
	    
	    if {$odd == 0} {
		.userlist.frame.can create rectangle [expr $x - 2] [expr $y - 12] [expr $x + 595 + 22] [expr $y + 11] -fill gray -outline gray
		set odd 1
	    } {
		.userlist.frame.can create rectangle [expr $x - 2] [expr $y - 12] [expr $x + 595 + 22] [expr $y + 11] -fill white -outline white
		set odd 0
	    }
	    
	    if {$invis($name) == 1} {
		catch {
		    .userlist.frame.can create image $x $y -anchor w -image $invis_image
		    .userlist.frame.can create rectangle [expr $x - 1] [expr $y -11] [expr $x + 20] [expr $y + 10]
		}
	    }
	    set x [expr $x + 24]
	    if {$wizinvis($name) == 1} {
		catch {
		    .userlist.frame.can  create image $x $y -anchor w -image $wizinvis_image
		    .userlist.frame.can  create rectangle [expr $x - 1] [expr $y -11] [expr $x + 20] [expr $y + 10]
		}
	    }
	    set x [expr $x + 24]
	    
	    if {$friend($name) == 1} {
		catch {
		    .userlist.frame.can create image $x $y -anchor w -image $friend_image -tags "friend_$name"
		    .userlist.frame.can create rectangle [expr $x - 1] [expr $y - 11] [expr $x + 20] [expr $y + 10]
		    .userlist.frame.can bind "friend_$name" <Button-1> "Userlist::change_friend $name"
		}
	    } {
		catch {
		    .userlist.frame.can create image $x $y -anchor w -image $blank_image -tags "friend_$name"
		    .userlist.frame.can bind "friend_$name" <Button-1> "Userlist::change_friend $name"
		}
	    }

	    set x [expr $x + 24]

	    if {$afk($name) == 1} {
		catch {
		    .userlist.frame.can create image $x $y -anchor w -image $afk_image
		    .userlist.frame.can create rectangle [expr $x - 1] [expr $y -11] [expr $x + 20] [expr $y + 10]
		}
	    }
	    
	    set x [expr $x + 24]

	    set file "$path$clan($name)"

	    catch {
		
		if {[catch {set current_image [image create photo -file $file.ppm -format ppm]}] == 1} {
		    set current_image [image create photo -file $file.gif -format gif]
		}
			
		.userlist.frame.can create image $x $y -tags "clan_$name" -anchor w -image $current_image
		.userlist.frame.can create rectangle [expr $x - 1] [expr $y -11] [expr $x + 70] [expr $y + 10]
		.userlist.frame.can bind "clan_$name" <Button-1> "Userlist::claninfo $clan($name)"
	    }
	    
	    set x [expr $x + 75]
	    .userlist.frame.can create text $x $y -tags "finger_$name" -anchor w -font $font -text "$name$title($name)"
	    .userlist.frame.can bind "finger_$name" <Button-1> "Userlist::finger $name"

	    set x [expr $x + 300]
	    .userlist.frame.can create text $x $y -anchor w -font $font -text "$rank($name)"

	    set x [expr $x + 100]
	    .userlist.frame.can create text $x $y -anchor w -font $font -text "$level($name)"
	    
	    set y [expr $y + 24]
	}

	.userlist.frame.can create rectangle 2 2 624 [expr $y - 12]

	set bbox [grid bbox .userlist.frame.can 0 0]
	set incr [lindex $bbox 3]
	set width [winfo reqwidth .userlist.frame.can]
	set height [winfo reqheight .userlist.frame.can]
	.userlist.frame.can config -scrollregion "0 0 $width [expr $y - 10]"
	.userlist.frame.can config -yscrollincrement $incr
	set height [expr 7 * $incr]
	.userlist.frame.can config -width $width -height [expr $y - 10]
    }
}

#Name is 3-12 characters long

#Mango
#Loon
#Mtf
#Karzan
